#include <iostream>
#include <algorithm>

using namespace std;

int ocena(int neopadajuci[], int nerastuci[], int n, int l) {
    int rez = 0;
    for(int i = 0; i < l; i++) {
        if(rez <= nerastuci[i])
            rez++;
        else
            rez--;
    }
    for(int i = l; i < n - l; i++) {
        if(rez <= neopadajuci[i])
            rez++;
        else
            rez--;
    }
    for(int i = n - l; i < n; i++) {
        if(rez <= nerastuci[i])
            rez++;
        else
            rez--;
    }
    return rez;
}

void ispisi(int neopadajuci[], int nerastuci[], int n, int l) {
    for(int i = 0; i < l; i++)
        cout << nerastuci[i] << ' ';
    for(int i = l; i < n - l; i++)
        cout << neopadajuci[i] << ' ';
    for(int i = n - l; i < n; i++)
        cout << nerastuci[i] << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    
    int t, n, k;
    cin >> t >> n >> k;
    int neopadajuci[n], nerastuci[n];
    for(int i = 0; i < n; i++) {
        cin >> neopadajuci[i];
        nerastuci[i] = neopadajuci[i];
    }
    
    sort(neopadajuci, neopadajuci + n);
    sort(nerastuci, nerastuci + n, greater<int>());
    
    int najmanjaOcena = ocena(neopadajuci, nerastuci, n, n/2);
    int najvecaOcena = ocena(neopadajuci, nerastuci, n, 0);
    
    if(najmanjaOcena <= k && k <= najvecaOcena && ((n & 1) == (k & 1))) {
        for(int i = 0; i <= n/2; i++) {
            int trenutnaOcena = ocena(neopadajuci, nerastuci, n, i);
            if(trenutnaOcena == k) {
                cout << "DA\n";
                ispisi(neopadajuci, nerastuci, n, i);
                return 0;
            }
        }
    }
    cout << "NE\n";
    
    return 0;
}